initSidebarItems({"constant":[["TLV",""]],"fn":[["enter_context","Sets `context` as the new current ImplicitCtxt for the duration of the function `f`"],["enter_global","Enters GlobalCtxt by setting up libsyntax callbacks and creating a initial TyCtxt and ImplicitCtxt. This happens once per rustc session and TyCtxts only exists inside the `f` function."],["get_tlv","This is used to get the pointer to the current ImplicitCtxt."],["set_tlv","Sets TLV to `value` during the call to `f`. It is restored to its previous value after. This is used to set the pointer to the new ImplicitCtxt."],["span_debug","This is a callback from libsyntax as it cannot access the implicit state in librustc otherwise"],["track_diagnostic","This is a callback from libsyntax as it cannot access the implicit state in librustc otherwise. It is used to when diagnostic messages are emitted and stores them in the current query, if there is one."],["with","Allows access to the TyCtxt in the current ImplicitCtxt. Panics if there is no ImplicitCtxt available"],["with_context","Allows access to the current ImplicitCtxt. Panics if there is no ImplicitCtxt available"],["with_context_opt","Allows access to the current ImplicitCtxt in a closure if one is available"],["with_fully_related_context","Allows access to the current ImplicitCtxt whose tcx field has the same global interner and local interner as the tcx argument passed in. This means the closure is given an ImplicitCtxt with the same 'tcx and 'gcx lifetimes as the TyCtxt passed in. This will panic if you pass it a TyCtxt which has a different global interner or a different local interner from the current ImplicitCtxt's tcx field."],["with_global","Creates a TyCtxt and ImplicitCtxt based on the GCX_PTR thread local. This is used in the deadlock handler."],["with_opt","Allows access to the TyCtxt in the current ImplicitCtxt. The closure is passed None if there is no ImplicitCtxt available"],["with_related_context","Allows access to the current ImplicitCtxt whose tcx field has the same global interner as the tcx argument passed in. This means the closure is given an ImplicitCtxt with the same 'gcx lifetime as the TyCtxt passed in. This will panic if you pass it a TyCtxt which has a different global interner from the current ImplicitCtxt's tcx field."],["with_thread_locals","Sets up the callbacks from libsyntax on the current thread"]],"static":[["GCX_PTR",""]],"struct":[["ImplicitCtxt","This is the implicit state of rustc. It contains the current TyCtxt and query. It is updated when creating a local interner or executing a new query. Whenever there's a TyCtxt value available you should also have access to an ImplicitCtxt through the functions in this module."]]});